<template>
  <div
    :class="{ 'scrollableOverlay-wrapper': scrollable }"
    v-scroll-lock="scrollable"
    class="filters">
    <div
      body-scroll-lock-ignore
      class="filterGroup scrollableOverlay-container __box-gray">
      <div class="filterGroup-header">
        <div class="heading _h2">
          Фильтры
        </div>
        <button
          @click="onClose"
          class="filterGroup-close">
          <img
            svg-inline
            src="~/assets/svg/redesign/cross.svg">
        </button>
      </div>

      <div class="filterGroup-item">
        <div class="filterGroup-vertical _end-block">
          <div class="filterGroup-field">
            <label class="filterGroup-label">Цена, ₽</label>
            <div class="inputGroup">
              <div class="input">
                <input
                  class="input-field"
                  type="text"
                  placeholder="От"
                  :disabled="hasLoading"
                  @keypress="isPrice"
                  v-model.number.lazy="values.filterMinPrice">
              </div>
              <div class="input">
                <input
                  class="input-field"
                  type="text"
                  placeholder="До"
                  :disabled="hasLoading"
                  @keypress="isPrice"
                  v-model.number.lazy="values.filterMaxPrice">
              </div>
            </div>
          </div>
          <div class="filterGroup-field _right-shift">
            <AppCheckbox
              :disabled="hasLoading"
              :checked="$options.checkboxState.CHECKED === values.filterIsWholesale"
              @change="change($event, 'filterIsWholesale')">
              <template #label>Оптовые скидки</template>
            </AppCheckbox>
          </div>
        </div>

        <div class="filterGroup-field">
          <AppSelect
            v-model="values.filterDelivery"
            :id="'filterDelivery'"
            :options="filters.filterDelivery"
            :track-by="'id'"
            :placeholder="'Срок доставки'"
            :classes="['_delivery', 'no-checkbox', 'multiselectThemeSmall']"
            :disabled="hasLoading"
            @select="change"
            @clear="clear('filterDelivery')"/>
        </div>

        <div class="filterGroup-field">
          <AppSelect
            v-if="filters.filterManufacturer"
            v-model="values.filterManufacturer"
            :id="'filterManufacturer'"
            :options="filters.filterManufacturer"
            :track-by="'id'"
            :placeholder="'Производитель'"
            :classes="['_manufacturer', 'no-checkbox', 'multiselectThemeSmall']"
            :disabled="hasLoading"
            @select="change"
            @clear="clear('filterManufacturer')"/>
        </div>

        <div
          class="filterGroup-field _end-block"
          v-if="filters.filterShop">
          <AppSelect
            v-model="values.filterShop"
            :options="filters.filterShop"
            :id="'filterShop'"
            :track-by="'id'"
            :placeholder="'Продавец'"
            :classes="['_seller', 'no-checkbox', 'multiselectThemeSmall']"
            :disabled="hasLoading"
            @select="change"
            @clear="clear('filterShop')"/>
        </div>

        <div class="filterGroup-vertical _end-block">
          <div
            v-if="filters.filterLocation || filters.filterMetro"
            class="filterGroup-field">
            <div class="selectGroup">
              <AppSelect
                v-model="values.filterLocation"
                :id="'filterLocation'"
                :options="filters.filterLocation"
                :track-by="'id'"
                :placeholder="'Город'"
                :classes="['_address', 'no-checkbox', 'multiselectThemeSmall']"
                :disabled="hasLoading"
                @select="change"
                @clear="onClearFilterLocation"/>
              <!--          TODO: Нет функционала-->
              <!--          <AppSelect-->
              <!--            placeholder="Район"-->
              <!--            :classes="['_address']"/>-->
              <AppSelect
                v-if="filters.filterMetro"
                v-model="values.filterMetro"
                :id="'filterMetro'"
                :options="filters.filterMetro"
                :disabled="!filters.filterMetro || !filters.filterMetro.length || hasLoading"
                :track-by="'id'"
                :placeholder="'Метро'"
                :classes="['_address','no-checkbox', 'multiselectThemeSmall']"
                @select="change"
                @clear="clear('filterMetro')"/>
            </div>
          </div>
          <div class="filterGroup-field">
            <AppCheckbox
              :disabled="!values.filterLocation || hasLoading"
              :checked="$options.checkboxState.CHECKED === values.filterOpenedNow"
              @change="change($event, 'filterOpenedNow')">
              <template #label>Открыто сейчас</template>
            </AppCheckbox>
          </div>
        </div>

      </div>

      <!-- <div class="filterGroup-item"> -->
      <!--  TODO: нет функционала    -->
      <!--      <div class="filterGroup-field">-->
      <!--        <AppCheckbox>-->
      <!--          <template #label>Проверенные аналоги</template>-->
      <!--        </AppCheckbox>-->
      <!--      </div>-->
      <!-- </div> -->

      <!-- <div class="filterGroup-item"> -->
      <!--      TODO: Нет этого функционала-->
      <!--      <div class="filterGroup-field">-->
      <!--        <AppCheckbox>-->
      <!--          <template #label>В наличии</template>-->
      <!--        </AppCheckbox>-->
      <!--      </div>-->
      <!-- </div> -->

      <!-- <div class="filterGroup-item"> -->

      <!-- <div
          class="filterGroup-field"
          v-if="filters.filterRating">
          <AppSelect
            v-model="values.filterRating"
            :options="filters.filterRating"
            :id="'filterRating'"
            :track-by="'id'"
            :placeholder="'Рейтинг продавца'"
            :classes="['_rating', 'no-checkbox', 'multiselectThemeSmall']"
            :disabled="hasLoading"
            @select="change"
            @clear="clear('filterRating')">
            <template
              slot="option"
              slot-scope="{ option }">
              <div class="row">
                <AppRating :current-rating="Number(option.id)"/>&nbsp;&nbsp;{{ option.id }}
              </div>
            </template>
            <template
              slot="singleLabel"
              slot-scope="{ option }">
              <AppRating :current-rating="Number(option.id)"/>&nbsp;&nbsp;{{ option.id }}
            </template>
          </AppSelect>
        </div> -->
      <!-- </div> -->

      <button
        @click="$emit('reset')"
        class="button buttonResetFilters buttonAsLink _light">
        <img
          svg-inline
          src="~/assets/svg/redesign/cross-bold.svg">
        Сбросить фильтры
      </button>

      <div class="filterGroup-footer">
        <AppButton @click.native="$emit('hide')">
          <template #button-item>
            Показать предложения
          </template>
        </AppButton>
      </div>
    </div>
  </div>
</template>

<script>
import AppCheckbox from '~/components/redesign/app-input/app-checkbox';
import AppSelect from '~/components/redesign/app-select/app-select';
import AppButton from '~/components/redesign/app-buttons/app-button';
import CheckboxState from '~/assets/js/enums/checkbox-state';
import AppRating from '../app-rating';

// TODO: Фильтры ничего об этом знать не должны. Сделать по анологии со страницей в КЗ
const initialValues = {
  filterLocation: null,
  filterMetro: null,
  filterIsWholesale: null,
  filterMinPrice: null,
  filterMaxPrice: null,
  filterManufacturer: null,
  filterShop: null,
  filterDelivery: null,
  filterRating: null,
  filterOpenedNow: null,
};

export default {
  name: 'PpnFilters',
  components: {
    AppRating,
    AppButton,
    AppSelect,
    AppCheckbox,
  },
  props: {
    grids: {
      type: Object,
      default() {
        return {};
      },
    },
    filters: {
      type: Object,
      default() {
        return {};
      },
    },
    value: {
      type: Object,
      default() { return Object.assign({}, initialValues); },
    },
    countFiltersSelected: {
      type: Number,
      default: 0,
    },
    hasLoading: {
      type: Boolean,
      default: false,
    },
    scrollable: {
      type: Boolean,
      default: false,
    },
  },
  data() {
    return {
      values: {},
    };
  },
  computed: {
    tooltipOpenNow() {
      if (!this.values.filterLocation) {
        return {
          content: 'Для отображения работающих в настоящий момент продавцов выберите Ваш город',
          classes: 'ui popup tooltip visible dark bottom',
          placement: 'bottom',
          trigger: 'hover',
          offset: 4,
          delay: 0,
        };
      }
      return '';
    },
  },
  watch: {
    'values.filterMinPrice'(newValue, oldValue) {
      if (newValue !== oldValue) {
        this.change(newValue, 'filterMinPrice');
      }
    },
    'values.filterMaxPrice'(newValue, oldValue) {
      if (newValue !== oldValue) {
        this.change(newValue, 'filterMaxPrice');
      }
    },
    value() {
      this.values = Object.assign({}, this.value);
    },
  },
  created() {
    this.values = Object.assign({}, this.value);
    this.$options.checkboxState = CheckboxState;
  },
  methods: {
    onClose() {
      this.$emit('hide');
    },
    isPrice(event) {
      // TODO: Need refactoring
      event = event || window.event;
      const charCode = event.which || event.keyCode;
      if (charCode > 31 && (charCode < 48 || charCode > 57)) {
        event.preventDefault();
      } else {
        return true;
      }
      return true;
    },
    change(option = null, filterName) {
      const newValue = typeof option === 'boolean' ? Number(option) : option;
      if (filterName === 'filterLocation') {
        this.values.filterMetro = null;
        this.values.filterOpenedNow = null;
      }

      if (filterName === 'filterMinPrice'
        && this.values.filterMaxPrice
        && option > this.values.filterMaxPrice) {
        return;
      }

      if (filterName === 'filterMaxPrice'
        && this.values.filterMinPrice
        && option < this.values.filterMinPrice) {
        return;
      }

      const value = { ...this.value, [filterName]: newValue };

      this.$emit('input', value);
    },
    clear(filterName) {
      if (!filterName) {
        return;
      }

      this.$emit('input', { ...this.value, [filterName]: null });
    },
    reset() {
      this.values = Object.assign({}, initialValues);
      this.$emit('input', Object.assign({}, initialValues));
    },
    onClearFilterLocation() {
      this.clear('filterLocation');
      this.$emit('clear-filter-location');
    },
  },
};
</script>

<style lang="postcss">
  .filters {
    .filterGroup {
      display: flex;
      flex-wrap: wrap;

      &-header,
      &-footer {
        display: none;
      }

      &-item {
        display: flex;
        align-items: flex-start;
      }

      &-vertical {
        display: flex;
        flex-direction: column;
        justify-content: center;
        min-height: var(--btn-height-small);

        .filterGroup-field {
          margin-bottom: .5rem;

          &:last-child {
            margin-bottom: 0;
          }
        }
      }

      &-field {
        display: flex;
        align-items: center;
        margin: 0 0.5rem;
      }

      &-field + &-field {
        margin-left: 0;
      }

      &-label {
        display: block;
        padding-right: 0.5rem;
        font-size: 0.75rem;
        font-weight: var(--font-weight-medium);
      }

      @media screen and (min-width: 981px) {
        position: relative;
        padding: 1rem;

        .multiselect {
          font-size: 0.75rem;

          &__select {
            width: 2rem;

            .svg {
              width: 0.5625rem;
              height: auto;
            }
          }

          &._delivery {
            width: 8.0225rem;
            min-width: 8.0625rem;
            max-width: 8.0625rem;
          }
          &._manufacturer {
            width: 8.75rem;
            min-width: 8.75rem;
            max-width: 8.75rem;
          }
          &._seller {
            width: 8.75rem;
            min-width: 8.75rem;
            max-width: 8.75rem;
          }
          &._rating {
            width: 9.5rem;
            min-width: 9.5rem;
            max-width: 9.5rem;
          }
          &._address {
            width: 11.5rem;
            max-width: 11.5rem;
            min-width: 11.5rem;
          }
        }

        .inputGroup {
          width: 10rem;

          .input-field {
            height: 1.75rem;
            min-height: 1.75rem;
            font-size: 0.75rem;
          }
        }

        .filterGroup-field {
          &._right-shift {
            margin-left: 3.6125rem;
          }
        }

        .buttonResetFilters {
          display: flex;
          align-self: flex-end;
          margin: -1rem 0 0 auto;
          padding: 0 0.5rem 0 2rem;
          height: 1.25rem;
          font-size: 0.75rem;
          font-weight: var(--font-weight-regular);
          .svg {
            margin-right: 0.5rem;
            width: 0.375rem;
            height: auto;
            fill: var(--color-main-lightest);
          }
        }
      }

      @media (min-width: 981px) and (max-width: 1200px) {
        padding-bottom: 0.5rem;

        .filterGroup {
          &-label {
            font-size: 0.875rem;
          }

          &-item {
            flex-wrap: wrap;
          }

          &-field {
            &._right-shift {
              margin-left: 0;
            }

            &:last-child {
              margin-bottom: 0.5rem;
            }
          }

          &-vertical {
            flex-direction: row;
          }
        }

        .inputGroup .input-field {
          height: var(--btn-height-regular);
          max-height: var(--btn-height-regular);
        }

        .multiselect {
          height: var(--btn-height-regular);
        }

        .buttonResetFilters {
          position: absolute;
          bottom: 1rem;
          right: 1rem;
          margin-top: 0;
          height: 2.375rem;
          font-size: 0.875rem;
          .svg {
            width: 0.5rem;
          }
        }
      }

      @media screen and (max-width: 980px) {
        position: fixed;
        z-index: var(--z-index-over-modal);
        top: 0;
        bottom: 0;
        left: 0;
        padding: 0 1.25rem;
        flex-direction: column;
        flex-wrap: nowrap;
        justify-content: flex-start;
        width: 100vw;
        height: 100%;
        background-color: var(--bg-lightest);
        overflow-x: hidden;
        border-radius: 0;
        box-shadow: none;

        &-header {
          z-index: calc(var(--z-index-over-modal) - 1);
          display: flex;
          justify-content: center;
          align-items: center;
          flex-shrink: 0;
          margin: 0 -1.25rem;
          width: 100vw;
          height: 4.375rem;
          background-color: var(--bg-main);
          border-bottom: 1px solid var(--border-color-main);
        }

        &-footer {
          display: flex;
          justify-content: center;
          align-items: flex-start;
          flex-shrink: 1;
          margin: -1px -1.25rem 0 -1.25rem;
          padding: 1rem 1.25rem calc(2rem + var(--mobile-browser-bar));
          width: 100vw;
          height: 100%;
          min-height: 7rem;
          background-color: var(--bg-main);
          border-top: 1px solid var(--border-color-main);

          .button {
            width: 100%;
            font-size: 1rem;
          }
        }

        &-close {
          position: absolute;
          top: 0;
          right: 0;
          display: flex;
          align-items: center;
          justify-content: center;
          width: 3.75rem;
          height: 3.75rem;
          background: none;
          border: none;
          box-shadow: none;

          .svg {
            width: 1.25rem;
            height: 1.25rem;
            fill: var(--fill-light);
          }
        }

        &-item, &-vertical {
          flex-direction: column;
          flex-shrink: 0;
          padding: 0;
          width: 100%;

          &._end-block {
            padding-bottom: 1.25rem;
            border-bottom: 1px solid var(--border-color-main);
          }
        }

        &-field {
          flex-direction: column;
          align-items: flex-start;
          margin: 0;
          padding-top: 1.25rem;
          width: 100%;
        }

        &-label {
          padding-bottom: 1.25rem;
          font-size: 1rem;
        }

        .inputGroup,
        .selectGroup,
        .multiselect {
          width: 100%;
        }

        .input-field,
        .inputCheck-label,
        .multiselect {
          font-size: 1rem;
        }

        .inputGroup .input-field {
          height: var(--btn-height-huge);
        }

        .selectGroup {
          flex-direction: column;
          .multiselect + .multiselect {
            margin-top: 1.25rem;
          }
          .multiselect__tags {
            border-radius: 0.25rem;
          }
        }

        .buttonResetFilters {
          padding: 1.25rem 0;
          font-size: 1rem;
          justify-content: flex-end;
          .svg {
            margin-right: 0.5rem;
            width: 0.625rem;
            height: auto;
            fill: var(--color-main-lightest);
          }
        }
      }
    }
  }
</style>
